<?php
/*******************************************************************************

    Author ......... 
    Contact ........ 
    Home Site ...... 
    Program ........ haloe for Cacti
    Version ........ 0.1
    Purpose ........ 

*******************************************************************************/

function plugin_init_haloe() {
	global $plugin_hooks;
	$plugin_hooks['top_header_tabs']['haloe'] = 'haloe_show_tab';
	$plugin_hooks['top_graph_header_tabs']['haloe'] = 'haloe_show_tab';
	$plugin_hooks['config_arrays']['haloe'] = 'haloe_config_arrays';
	$plugin_hooks['draw_navigation_text']['haloe'] = 'haloe_draw_navigation_text';
	$plugin_hooks['config_form']['haloe'] = 'haloe_config_form';
	$plugin_hooks['top_graph_refresh']['haloe'] = 'haloe_top_graph_refresh';
	$plugin_hooks['config_settings']['haloe'] = 'haloe_config_settings';
}

function haloe_config_settings () {
	global $tabs, $settings;
	$tabs["misc"] = "Misc";

	$temp = array(
		"haloe_header" => array(
			"friendly_name" => "Syslog",
			"method" => "spacer",
			),
		"haloe_refresh" => array(
			"friendly_name" => "Refresh Interval",
			"description" => "This is the time in seconds before the page refreshes.  (1 - 300)",
			"method" => "textbox",
			"max_length" => 3,
			),
	);

	if (isset($settings["misc"]))
		$settings["misc"] = array_merge($settings["misc"], $temp);
	else
		$settings["misc"]=$temp;
}

function haloe_top_graph_refresh ($refresh) {
	if (basename($_SERVER["PHP_SELF"]) != "haloe.php")
		return $refresh;
	$r = read_config_option("haloe_refresh");
	if ($r == '' or $r < 1)
		return $refresh;
	return $r;
}

function haloe_show_tab () {
	global $config, $user_auth_realms, $user_auth_realm_filenames;
	$realm_id2 = 0;

	if (isset($user_auth_realm_filenames{basename('haloe.php')})) {
		$realm_id2 = $user_auth_realm_filenames{basename('haloe.php')};
	}
	if ((db_fetch_assoc("select user_auth_realm.realm_id
		from user_auth_realm where user_auth_realm.user_id='" . $_SESSION["sess_user_id"] . "'
		and user_auth_realm.realm_id='$realm_id2'")) || (empty($realm_id2))) {

		print '<a href="' . $config['url_path'] . 'plugins/haloe/haloe.php"><img src="' . $config['url_path'] . 'plugins/haloe/images/tab_haloe.gif" alt="haloe" align="absmiddle" border="0"></a>';

	}

	haloe_setup_table();

	$r = read_config_option("haloe_refresh");
	$sql = "select * from settings where name='haloe_refresh'";
	$result = db_fetch_assoc($sql);
	if (!isset($result[0]['name']))
		$r = NULL;
	if ($r == '' or $r < 1 or $r > 300) {
		if ($r == '')
			$sql = "replace into settings values ('haloe_refresh','300')";
		else if ($r == NULL)
			$sql = "insert into settings values ('haloe_refresh','300')";
		else
			$sql = "update settings set value = '300' where name = 'haloe_refresh'";
		$result = mysql_query($sql) or die (mysql_error());
		kill_session_var("sess_config_array");
	}
}

function haloe_config_arrays () {
	global $user_auth_realms, $user_auth_realm_filenames;
	$user_auth_realms[37]='View Syslog';
	$user_auth_realm_filenames['haloe.php'] = 37;
}

function haloe_draw_navigation_text ($nav) {
   $nav["haloe.php:"] = array("title" => "haloe", "mapping" => "index.php:", "url" => "haloe.php", "level" => "1");
   $nav["haloe.php:actions"] = array("title" => "haloe", "mapping" => "index.php:", "url" => "haloe.php", "level" => "1");
   return $nav;
}

function haloe_setup_table () {
// Return for now until I fix the seperate database issue
return;
	global $config, $database_default;
	include_once($config["library_path"] . "/database.php");
	$sql = "show tables from " . $database_default;
	
	$result = db_fetch_assoc($sql) or die (mysql_error());

	$tables = array();

	foreach($result as $index => $arr) {
		foreach ($arr as $t) {
			$tables[] = $t;
		}
	}

	if (!in_array('haloe_logs', $tables)) {
		$sql = "CREATE TABLE haloe_logs (
			host varchar(32) default NULL,
			facility varchar(10) default NULL,
			priority varchar(10) default NULL,
			level varchar(10) default NULL,
			tag varchar(10) default NULL,
			date date default NULL,
			time time default NULL,
			program varchar(15) default NULL,
			msg text,
			seq int(10) unsigned NOT NULL auto_increment,
			PRIMARY KEY (seq),
			KEY host (host),
			KEY seq (seq),
			KEY program (program),
			KEY time (time),
			KEY date (date),
			KEY priority (priority),
			KEY facility (facility)
			) TYPE=MyISAM;";
		$result = mysql_query($sql) or die (mysql_error());
	}
}

function haloe_version () {
	return array( 'name' 	=> 'haloe',
			'version' 	=> '0.1');
}

?>